<?php
/*
Plugin Name: NS Free Price and Donation for WooCommerce
Plugin URI: http://nsthemes.com
Description: Insert free price to one or many product
Version: 2.1.3
Author: NsThemes
Author URI: http://nsthemes.com
License: GNU General Public License v2.0
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

if ( ! defined( 'GIFT_PRICE_NS_PLUGIN_DIR' ) )
    define( 'GIFT_PRICE_NS_PLUGIN_DIR', untrailingslashit( dirname( __FILE__ ) ) );

if ( ! defined( 'GIFT_PRICE_NS_PLUGIN_URL' ) )
    define( 'GIFT_PRICE_NS_PLUGIN_URL', plugin_dir_url( __FILE__ ) );



add_action( 'woocommerce_before_calculate_totals', 'add_custom_price' );

function add_custom_price( $cart_object ) {
	
	foreach ( $cart_object->cart_contents as $key => $value ) {
		if(get_post_meta($value['product_id'], 'ns_gift_price_custom_tab', true) == 'yes') {
			$arr_temp_new_price = get_post_meta($value['product_id'], $key);
			$value['data']->set_price($arr_temp_new_price[0]);
			$value['data']->set_regular_price($arr_temp_new_price[0]);
			$value['data']->set_sale_price($arr_temp_new_price[0]);
		}
	}
}

add_action( 'save_post', 'ns_gp_my_product_update' , 10, 3);

function ns_gp_my_product_update( $post_id, $post, $update ) {
    if($post->post_type == "product"){
	if (isset($_POST['ns_gift_price_custom_tab']) AND $_POST['ns_gift_price_custom_tab'] != '') {
			$ns_gift_price_custom_tab = sanitize_text_field($_POST['ns_gift_price_custom_tab']);
	} else {
		$ns_gift_price_custom_tab = 0;
	}
		if($ns_gift_price_custom_tab) {
			update_post_meta($post->ID, '_sold_individually', 'yes');
			update_post_meta($post->ID, '_regular_price', '0');
		}
    }
}

function action_woocommerce_add_to_cart( $array, $inta, $intb ) {
	$new_price = sanitize_text_field($_POST['new_price']);
	if (isset($new_price)) {
		if (!add_post_meta($inta, $array, $new_price, true)) {
			update_post_meta( $inta, $array, $new_price );
		}
	}
}

add_action( 'woocommerce_add_to_cart', 'action_woocommerce_add_to_cart', 10, 3 ); 

/* *** include css admin *** */
function ns_gift_price_css_admin( $hook ) {
	wp_enqueue_style('ns-free-price-and-donation-style-admin', GIFT_PRICE_NS_PLUGIN_URL . '/css/ns-free-price-and-donation-for-woocommerce-admin.css');
}
add_action( 'admin_enqueue_scripts', 'ns_gift_price_css_admin' );

/* *** include css *** */
function ns_gift_price_css( $hook ) {
	wp_enqueue_style('ns-free-price-and-donation-for-woocommerce-style', GIFT_PRICE_NS_PLUGIN_URL . '/css/ns-free-price-and-donation-for-woocommerce.css');
}
add_action( 'wp_enqueue_scripts', 'ns_gift_price_css' );

/* *** include single product free price and donation *** */
require_once( GIFT_PRICE_NS_PLUGIN_DIR.'/ns-free-price-and-donation-for-woocommerce-single-product.php');

/* *** include loop product free price and donation *** */
require_once( GIFT_PRICE_NS_PLUGIN_DIR.'/ns-free-price-and-donation-for-woocommerce-loop.php');

/* *** include admin option *** */
require_once( GIFT_PRICE_NS_PLUGIN_DIR.'/ns-free-price-and-donation-for-woocommerce-admin.php');

// Add the custom tab in woocommerce product page
require_once( GIFT_PRICE_NS_PLUGIN_DIR.'/ns-free-price-and-donation-for-woocommerce-add-tab.php');

function ns_gift_price_activate_set_default_options() {
    add_option('ns_gp_enabled_plugin', 'on');
}
 
register_activation_hook( __FILE__, 'ns_gift_price_activate_set_default_options');

function ns_donation_catalog_free_add_option_page() {
    add_menu_page('Donation', 'Donation', 'manage_options', 'ns-donation-options-page-free', 'ns_donation_update_options_form', GIFT_PRICE_NS_PLUGIN_URL.'/img/backend-sidebar-icon.png', 60);
}
 
add_action('admin_menu', 'ns_donation_catalog_free_add_option_page');

?>